cmake_minimum_required(VERSION 3.0)

# Declaring variables
set(PLATFORM_DIR "${CMAKE_CURRENT_LIST_DIR}")

if ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "aarch64")
    set(ARCH_DIR "arm64")
elseif ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "AMD64|x86_64")
    if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "4")
        set(ARCH_DIR "x86")
    elseif ("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
        set(ARCH_DIR "x64")
    endif ()
else ()
    message(FATAL_ERROR "Unable to determine CPU architecture")
endif ()

if (UNIX)
    find_program(LSB_RELEASE_EXEC lsb_release)
    execute_process(COMMAND ${LSB_RELEASE_EXEC} --codename OUTPUT_VARIABLE LSB_RELEASE_CODENAME OUTPUT_STRIP_TRAILING_WHITESPACE)

    if (LSB_RELEASE_CODENAME MATCHES "xenial")
        set(PLATFORM_DIR "${CMAKE_CURRENT_LIST_DIR}/ubuntu16_04/gcc5_4_0/${ARCH_DIR}")
    elseif (LSB_RELEASE_CODENAME MATCHES "bionic")
        set(PLATFORM_DIR "${CMAKE_CURRENT_LIST_DIR}/ubuntu18_04/gcc7_4_0/${ARCH_DIR}")
    elseif (LSB_RELEASE_CODENAME MATCHES "Core")
        set(PLATFORM_DIR "${CMAKE_CURRENT_LIST_DIR}/centos7/gcc7_3_1/${ARCH_DIR}")
    endif ()

elseif (WIN32)
    set(PLATFORM_DIR "${CMAKE_CURRENT_LIST_DIR}/windows/vc142/${ARCH_DIR}")
endif ()

function(add_shared_lib LIB STATIC_LIB_VERSION SHARED_LIB_VERSION)
    message(STATUS "Adding library '${LIB}'. Reference the library using the TARGET '${LIB}'")

    add_library("${LIB}" SHARED IMPORTED GLOBAL)

    if (UNIX)
        set_target_properties("${LIB}" PROPERTIES IMPORTED_LOCATION_DEBUG "${PLATFORM_DIR}/debug/lib/${CMAKE_SHARED_LIBRARY_PREFIX}${LIB}${STATIC_LIB_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}")
        set_target_properties("${LIB}" PROPERTIES IMPORTED_LOCATION_RELEASE "${PLATFORM_DIR}/release/lib/${CMAKE_SHARED_LIBRARY_PREFIX}${LIB}${STATIC_LIB_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}")
    elseif (WIN32)
        set_target_properties("${LIB}" PROPERTIES IMPORTED_IMPLIB_DEBUG "${PLATFORM_DIR}/debug/lib/${LIB}${STATIC_LIB_VERSION}${CMAKE_STATIC_LIBRARY_SUFFIX}")
        set_target_properties("${LIB}" PROPERTIES IMPORTED_LOCATION_DEBUG "${PLATFORM_DIR}/debug/lib/${LIB}${SHARED_LIB_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}")
        set_target_properties("${LIB}" PROPERTIES IMPORTED_IMPLIB_RELEASE "${PLATFORM_DIR}/release/lib/${LIB}${STATIC_LIB_VERSION}${CMAKE_STATIC_LIBRARY_SUFFIX}")
        set_target_properties("${LIB}" PROPERTIES IMPORTED_LOCATION_RELEASE "${PLATFORM_DIR}/release/lib/${LIB}${SHARED_LIB_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endfunction(add_shared_lib)

file(GLOB _GSTREAMER_DEPS_REL "${PLATFORM_DIR}/release/lib/*${CMAKE_SHARED_LIBRARY_SUFFIX}*")
file(GLOB _GSTREAMER_DEPS_DBG "${PLATFORM_DIR}/debug/lib/*${CMAKE_SHARED_LIBRARY_SUFFIX}*")
list(FILTER _GSTREAMER_DEPS_REL EXCLUDE REGEX "${CMAKE_SHARED_LIBRARY_SUFFIX}\\.a")
list(FILTER _GSTREAMER_DEPS_DBG EXCLUDE REGEX "${CMAKE_SHARED_LIBRARY_SUFFIX}\\.a")
set(GSTREAMER_DEPS_REL ${_GSTREAMER_DEPS_REL} PARENT_SCOPE)
set(GSTREAMER_DEPS_DBG ${_GSTREAMER_DEPS_DBG} PARENT_SCOPE)

file(GLOB _GSTREAMER_PLUGIN_DEPS_REL "${PLATFORM_DIR}/release/lib/gstreamer-1.0/*${CMAKE_SHARED_LIBRARY_SUFFIX}*")
file(GLOB _GSTREAMER_PLUGIN_DEPS_DBG "${PLATFORM_DIR}/debug/lib/gstreamer-1.0/*${CMAKE_SHARED_LIBRARY_SUFFIX}*")
list(FILTER _GSTREAMER_PLUGIN_DEPS_REL EXCLUDE REGEX "${CMAKE_SHARED_LIBRARY_SUFFIX}\\.a")
list(FILTER _GSTREAMER_PLUGIN_DEPS_DBG EXCLUDE REGEX "${CMAKE_SHARED_LIBRARY_SUFFIX}\\.a")
set(GSTREAMER_PLUGIN_DEPS_REL ${_GSTREAMER_PLUGIN_DEPS_REL} PARENT_SCOPE)
set(GSTREAMER_PLUGIN_DEPS_DBG ${_GSTREAMER_PLUGIN_DEPS_DBG} PARENT_SCOPE)

function(copy_gstreamer_deps TARGET)
    # Using the true command to skip the post build steps we don't need for a configuration, as interpreting a list changes the delimeter to semicolons when I need spaces still
    add_custom_command(TARGET ${TARGET} POST_BUILD COMMAND ${CMAKE_COMMAND} -E "$<$<CONFIG:Debug>:true>" copy_if_different ${GSTREAMER_DEPS_REL} "$<TARGET_FILE_DIR:${TARGET}>")
    add_custom_command(TARGET ${TARGET} POST_BUILD COMMAND ${CMAKE_COMMAND} -E "$<$<CONFIG:Release>:true>" copy_if_different ${GSTREAMER_DEPS_DBG} "$<TARGET_FILE_DIR:${TARGET}>")
    add_custom_command(TARGET ${TARGET} POST_BUILD COMMAND ${CMAKE_COMMAND} -E make_directory "$<TARGET_FILE_DIR:${TARGET}>/gstreamer-1.0/")
    add_custom_command(TARGET ${TARGET} POST_BUILD COMMAND ${CMAKE_COMMAND} -E "$<$<CONFIG:Debug>:true>" copy_if_different ${GSTREAMER_PLUGIN_DEPS_REL} "$<TARGET_FILE_DIR:${TARGET}>/gstreamer-1.0/")
    add_custom_command(TARGET ${TARGET} POST_BUILD COMMAND ${CMAKE_COMMAND} -E "$<$<CONFIG:Release>:true>" copy_if_different ${GSTREAMER_PLUGIN_DEPS_DBG} "$<TARGET_FILE_DIR:${TARGET}>/gstreamer-1.0/")
endfunction(copy_gstreamer_deps)

set(GSTREAMER_INCLUDE_DIRS ${GLIB_INCLUDE_DIRS} PARENT_SCOPE)
set(GSTREAMER_CFLAGS_OTHER ${GLIB_CFLAGS_OTHER} PARENT_SCOPE)
set(GSTREAMER_LIB_DEPS gstcodecparsers gstapp gstwebrtc gstsdp gstcontroller gstbase gstreamer glib gmodule gobject PARENT_SCOPE)

add_shared_lib(glib "-2.0" "-2.0-0")
add_shared_lib(gmodule "-2.0" "-2.0-0")
add_shared_lib(gobject "-2.0" "-2.0-0")

add_shared_lib(gstreamer "-1.0" "-1.0-0")
set_property(TARGET gstreamer APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${PLATFORM_DIR}/include")
set_property(TARGET gstreamer APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${PLATFORM_DIR}/include/gstreamer-1.0")
set_property(TARGET gstreamer APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${PLATFORM_DIR}/include/glib-2.0")

add_shared_lib(gstbase "-1.0" "-1.0-0")
add_shared_lib(gstcontroller "-1.0" "-1.0-0")
add_shared_lib(gstgl "-1.0" "-1.0-0")
add_shared_lib(gstvideo "-1.0" "-1.0-0")
add_shared_lib(gstwebrtc "-1.0" "-1.0-0")
add_shared_lib(gstsdp "-1.0" "-1.0-0")
add_shared_lib(gstapp "-1.0" "-1.0-0")
add_shared_lib(gstcodecparsers "-1.0" "-1.0-0")
